#include "readfile.h"
#include "myutil.h"
#include <stdio.h>
#include<stdlib.h>
#include<string.h>
char* read_srccodefile::read(char filename[])
{
    bool flg_notread = false;
    bool flg_yomitobashi=false;
    char c;
    fp = fopen(filename, "r");
    if(fp==NULL)return NULL;
    while ((c = fgetc(fp)) != EOF)
      {
          if (c == '#')
              flg_notread = true;      //インラインコメントも読まない
          if (c == '\n')
              flg_yomitobashi = true;      //改行コードは読まない
          if (flg_notread == false)
              addchar(c);
          if (c == '\n')
              flg_notread = false;     //改行が来たら後は読む
      }
    return codebuf;
}

void read_srccodefile::addchar(char c)
{
    char *p;
    if(strsize<strlen(codebuf)+2)//確保したメモリサイズが足りなかったら
      {
        addmem();//追加で確保
//exit(1);
      }
    p=strrchr(codebuf,'\0');
    *(p+0)=c;
    *(p+1)='\0';
}
bool read_srccodefile::addmem()
{
    char *mbuf;
    strsize+=32;
    mbuf = (char *) malloc((strsize*sizeof(char)));
    //strcpy(mbuf, codebuf);
    sprintf(mbuf,"%s",codebuf);
    free(codebuf);
    codebuf = mbuf;
}


read_srccodefile::read_srccodefile()
{
    strsize = 128;
    codebuf=(char *)malloc(sizeof(char)*strsize);
}

read_srccodefile::~read_srccodefile()
{
//     free(codebuf);
}
