#include<stdio.h>
#include "./delta.h"
#include<stdlib.h>
#include<math.h>
#include<string.h>



void makedelta(char *in1, char *in2, char *deltafile)
{
    bool flg;
    FILE *moto, *kyokuhennkei, *output;
    moto = fopen(in1, "r");
    if(moto==NULL){printf("変形前ファイルが開けません");exit(1);}
    kyokuhennkei = fopen(in2, "r");
    if(kyokuhennkei==NULL){printf("変形後ファイルが開けません");exit(1);}
    output = fopen(deltafile, "w");
    if(output==NULL){printf("差分出力先ファイルが開けません");exit(1);}
    double data1, data2;
    char buf[2][256];
    char table[5][16] = { "SECTION", "ENTITIES", "3DFACE", "ENDSEC", "EOF" };
    while (true)
      {
          if (fscanf(moto, "%s", buf[0]) == EOF)
              break;
          if (fscanf(kyokuhennkei, "%s", buf[1]) == EOF)
              break;
          fprintf(output, "%s\n", buf[0]);
          fscanf(moto, "%s", buf[0]);
          fscanf(kyokuhennkei, "%s", buf[1]);
          flg = true;
          for (int i = 0; i < 5; i++)
            {
                if (strcmp(table[i], buf[0]) == 0)
                    flg = false;
            }
          if (flg == true)
            {
                fprintf(output, "%.15lf\n", atof(buf[0]) - atof(buf[1]));
          } else
              fprintf(output, "%s\n", buf[0]);
      }
    fclose(moto);
    fclose(kyokuhennkei);
    fclose(output);
}
